"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const generator_1 = require("./generator");
class ClientGenerator extends generator_1.FileGenerator {
    constructor(file, queryApiFilename, mutationApiFilename) {
        super(file);
        this.queryApiFilename = queryApiFilename;
        this.mutationApiFilename = mutationApiFilename;
    }
    getContent() {
        return __awaiter(this, void 0, void 0, function* () {
            const code = `
import { QueryApi } from './${this.queryApiFilename}';
import { MutationApi } from './${this.mutationApiFilename}';
import { IGraphQlQueryExecutor } from 'graphql-client-ts';


export class GraphQLClient {
    constructor(protected readonly executor: IGraphQlQueryExecutor) { }

    query<T extends {}>() {
        return new QueryApi<T>(this.executor);
    }

    mutation<T extends {}>() {
        return new MutationApi<T>(this.executor);
    }
}`;
            return code;
        });
    }
}
exports.ClientGenerator = ClientGenerator;
