"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class GraphQlQuery {
    constructor(executor, type) {
        this.executor = executor;
        this.type = type;
        this.items = {};
    }
    queryHasItems() {
        return Object.keys(this.items).length > 0;
    }
    queryAddItem(key, item) {
        this.items[key] = item;
        return this;
    }
    queryExecute() {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield this.executor.execute(this.type, this.items);
            const keys = Object.keys(this.items);
            for (let key of keys) {
                if (this.items[key].mapper) {
                    result.data[key] = this.items[key].mapper(result.data[key]);
                }
            }
            return result;
        });
    }
}
exports.GraphQlQuery = GraphQlQuery;
