"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_executor_1 = require("./graphql-executor");
var LRU = require("lru-cache");
var debug = require("debug")("gamebot:api-client");
var CacheGraphQlQueryExecutor = (function (_super) {
    __extends(CacheGraphQlQueryExecutor, _super);
    function CacheGraphQlQueryExecutor(request, cacheOptions) {
        var _this = _super.call(this, request) || this;
        _this.storage = {};
        for (var _i = 0, _a = Object.keys(cacheOptions); _i < _a.length; _i++) {
            var key = _a[_i];
            _this.storage[key] = new LRU({
                max: cacheOptions[key].max,
                maxAge: cacheOptions[key].ttl
            });
        }
        return _this;
    }
    CacheGraphQlQueryExecutor.prototype.execute = function (type, items) {
        return __awaiter(this, void 0, void 0, function () {
            var result, nonCacheItems, keys, hasNonCacheItems, _i, keys_1, key, item, cache, itemKey, value, remoteResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (type !== "query") {
                            return [2, _super.prototype.execute.call(this, type, items)];
                        }
                        result = { data: {} };
                        nonCacheItems = {};
                        keys = Object.keys(items);
                        hasNonCacheItems = false;
                        for (_i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
                            key = keys_1[_i];
                            item = items[key];
                            cache = this.storage[item.name];
                            if (cache) {
                                itemKey = this.createItemKey(item);
                                value = cache.get(itemKey);
                                if (value !== undefined) {
                                    result.data[key] = value;
                                    continue;
                                }
                            }
                            nonCacheItems[key] = item;
                            hasNonCacheItems = true;
                        }
                        if (!hasNonCacheItems) {
                            debug("none non-cache items!");
                            return [2, result];
                        }
                        return [4, _super.prototype.execute.call(this, type, nonCacheItems)];
                    case 1:
                        remoteResult = _a.sent();
                        if (remoteResult.data) {
                            this.setCacheData(remoteResult.data, nonCacheItems);
                        }
                        result.data = Object.assign(result.data, remoteResult.data);
                        if (remoteResult.errors) {
                            result.errors = remoteResult.errors;
                        }
                        return [2, result];
                }
            });
        });
    };
    CacheGraphQlQueryExecutor.prototype.setCacheData = function (data, items) {
        for (var key in data) {
            var item = items[key];
            var cache = this.storage[item.name];
            if (!cache) {
                continue;
            }
            var value = data[key];
            if (value !== undefined) {
                var itemKey = this.createItemKey(item);
                cache.set(itemKey, value);
            }
        }
    };
    CacheGraphQlQueryExecutor.prototype.createItemKey = function (item) {
        return (item.name +
            "#" +
            (item.variables
                ? JSON.stringify(item.variables.map(function (item) { return item.value; }))
                : "") +
            "#" +
            item.fields || "");
    };
    return CacheGraphQlQueryExecutor;
}(graphql_executor_1.GraphQlQueryExecutor));
exports.CacheGraphQlQueryExecutor = CacheGraphQlQueryExecutor;
