"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var generator_1 = require("./generator");
var schema_1 = require("./schema");
var utils_1 = require("../utils");
var ApiGenerator = (function (_super) {
    __extends(ApiGenerator, _super);
    function ApiGenerator(schemaData, file, type, apiTypesFilename) {
        var _this = _super.call(this, file) || this;
        _this.schemaData = schemaData;
        _this.type = type;
        _this.apiTypesFilename = apiTypesFilename;
        return _this;
    }
    ApiGenerator.prototype.getContent = function () {
        return __awaiter(this, void 0, void 0, function () {
            var methods, api;
            return __generator(this, function (_a) {
                methods = this.type === "mutation"
                    ? this.generateMutationMethods()
                    : this.generateQueryMethods();
                api = this.generateApi(this.type);
                return [2, [api.data, methods.data].join("\n\n")];
            });
        });
    };
    ApiGenerator.prototype.generateMutationMethods = function () {
        var schema = this.schemaData.schema;
        var type;
        if (schema.data.__schema["mutationType"]) {
            var typeName = schema.data.__schema["mutationType"].name;
            type = this.schemaData.getTypeByName(typeName);
        }
        return generateMethods("mutation", type);
    };
    ApiGenerator.prototype.generateQueryMethods = function () {
        var schema = this.schemaData.schema;
        var typeName = schema.data.__schema["queryType"].name;
        var type = this.schemaData.getTypeByName(typeName);
        return generateMethods("query", type);
    };
    ApiGenerator.prototype.generateApi = function (action) {
        return generateApi(action, this.schemaData, this.apiTypesFilename);
    };
    return ApiGenerator;
}(generator_1.FileGenerator));
exports.ApiGenerator = ApiGenerator;
function generateApi(action, schemaData, apiTypesFilename) {
    var schema = schemaData.schema;
    var typeExists = !!schema.data.__schema[action + "Type"];
    var type = typeExists
        ? schemaData.getTypeByName(schema.data.__schema[action + "Type"].name)
        : { fields: [] };
    var upperAction = utils_1.startWithUpperCase(action);
    var importedTypes = [];
    var hasDataField = false;
    var methods = type.fields.map(function (field) {
        var methodName = field.name.includes("_")
            ? field.name.split("_")[0] + utils_1.startWithUpperCase(field.name.split("_")[1])
            : field.name;
        var methodArgsData = [{ name: "key", type: "keyof T" }];
        var resultIsObject = schemaData.typeIsObject(field.type) ||
            (schema_1.typeIsList(field.type) &&
                schemaData.typeIsObject(field.type.ofType.ofType));
        if (resultIsObject) {
            methodArgsData.push({ name: "data", type: "GraphQlQueryItemInput" });
            hasDataField = true;
        }
        var argData = {
            name: "args",
            type: schema_1.generateTypeScriptType(field.args.map(function (arg) {
                var typeName = schema_1.getJsTypeName(arg.type);
                if (schemaData.typeIsObject(arg.type)) {
                    importedTypes.push(schema_1.getTypeName(arg.type));
                }
                return {
                    name: arg.name,
                    type: typeName,
                    required: schema_1.typeIsRequired(arg.type)
                };
            }))
        };
        if (field.args && field.args.length) {
            methodArgsData.push(argData);
        }
        var resultJsType = schema_1.getJsTypeName(field.type);
        if (schemaData.typeIsObject(field.type)) {
            importedTypes.push(schema_1.getTypeName(field.type));
        }
        methodArgsData.push({
            name: "mapper?",
            type: "IDataMapper<MR, " + resultJsType + ">"
        });
        var methodArgs = methodArgsData.map(function (item) { return item.name + ":" + item.type; });
        var variables = field.args.map(function (arg) {
            var typeName = schema_1.getTypeName(arg.type);
            if (schema_1.typeIsList(arg.type)) {
                if (arg.type.ofType &&
                    arg.type.ofType.ofType &&
                    schema_1.typeIsRequired(arg.type.ofType.ofType)) {
                    typeName += "!";
                }
                typeName = "[" + typeName + "]";
            }
            if (schema_1.typeIsRequired(arg.type)) {
                typeName += "!";
            }
            return "{ name: '" + arg.name + "', value: args." + arg.name + ", type: '" + typeName + "' }";
        });
        var methodBody = "return this._client.queryAddItem(key,\n            {\n                " + (resultIsObject ? "fields: data.fields," : "") + "\n                name: " + upperAction + "Methods." + field.name + ",\n                mapper: mapper,\n                variables: [\n                    " + variables.join(",\n") + "\n                ]\n            })";
        return methodName + "<MR>(" + methodArgs.join(",\n") + ") {\n        \n        " + methodBody + "\n    }";
    });
    var data = "\nimport { " + utils_1.uniq(importedTypes).join(", ") + " } from './" + apiTypesFilename + "';\nimport { GraphQlRequestResult, GraphQlQuery, IGraphQlQueryExecutor, " + (hasDataField ? "GraphQlQueryItemInput," : "") + " IDataMapper } from 'graphql-client-ts';\n\nexport class " + upperAction + "Api<T> {\n    protected _client: GraphQlQuery<T, " + upperAction + "Methods>;\n    constructor(executor: IGraphQlQueryExecutor) {\n        this._client = new GraphQlQuery<T, " + upperAction + "Methods>(executor, '" + action + "');\n    }\n    queryHasItems() {\n        return this._client.queryHasItems();\n    }\n    async queryExecute(): Promise<GraphQlRequestResult<T>> {\n        return this._client.queryExecute();\n    }\n    " + methods.join("\n\n") + "\n}\n    ";
    return {
        name: upperAction + "Api",
        data: data
    };
}
function generateMethods(action, type) {
    var names = type
        ? type.fields.map(function (field) { return "    " + field.name + " = \"" + field.name + "\""; })
        : [];
    var name = utils_1.startWithUpperCase(action) + "Methods";
    var data = "export enum " + name + " {\n" + names.join(",\n") + "\n}";
    return { name: name, data: data };
}
