"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var program = require("commander");
var schema_1 = require("./schema");
var types_generator_1 = require("./types-generator");
var path_1 = require("path");
var api_generator_1 = require("./api-generator");
var client_generator_1 = require("./client-generator");
program
    .version("0.1.0")
    .option("-o, --output <value>", "Output path")
    .option("-p, --endpoint <value>", "Api endpoint")
    .option("-h, --headers [value]", "Headers", function (h) { return JSON.parse(h); })
    .parse(process.argv);
var output = program.output || process.cwd();
var endpoint = program.endpoint;
var headers = program.headers;
if (!endpoint) {
    throw new Error("--endpoint is required!");
}
function run() {
    return __awaiter(this, void 0, void 0, function () {
        var schemaData, typesFilename, typesGenerator, queryApiFilename, queryApiGenerator, mutationApiFilename, mutationApiGenerator, clientFilename, clientGenerator;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("output: " + output);
                    console.log("endpoint: " + endpoint);
                    console.log("headers: " + headers);
                    return [4, schema_1.SchemaData.create(endpoint, headers)];
                case 1:
                    schemaData = _a.sent();
                    typesFilename = "api-types";
                    typesGenerator = new types_generator_1.TypesGenerator(schemaData, path_1.join(output, typesFilename + ".ts"));
                    queryApiFilename = "query-api";
                    queryApiGenerator = new api_generator_1.ApiGenerator(schemaData, path_1.join(output, queryApiFilename + ".ts"), "query", typesFilename);
                    mutationApiFilename = "mutation-api";
                    mutationApiGenerator = new api_generator_1.ApiGenerator(schemaData, path_1.join(output, mutationApiFilename + ".ts"), "mutation", typesFilename);
                    clientFilename = "graphql-client";
                    clientGenerator = new client_generator_1.ClientGenerator(path_1.join(output, clientFilename + ".ts"), queryApiFilename, mutationApiFilename);
                    return [4, typesGenerator.generate()];
                case 2:
                    _a.sent();
                    return [4, queryApiGenerator.generate()];
                case 3:
                    _a.sent();
                    return [4, mutationApiGenerator.generate()];
                case 4:
                    _a.sent();
                    return [4, clientGenerator.generate()];
                case 5:
                    _a.sent();
                    return [2];
            }
        });
    });
}
run()
    .then(function () { return console.log("OK!"); })
    .catch(function (e) { return console.trace(e); });
