export declare class SchemaData {
    readonly schema: any;
    constructor(schema: any);
    getTypeByName(name: string): TypeData;
    typeIsObject(type: TypeData): boolean;
    typeIsObjectOrEnum(type: TypeData): boolean;
    typeIsEnum(type: TypeData): boolean;
    isOfType(type: TypeData, types: string[]): boolean;
    static create(url: string, headers?: any): Promise<SchemaData>;
}
export declare function saveCodeFile(data: GeneratedInfo[], fileName: string): void;
export declare function generateTypeScriptType(items: {
    name: string;
    type: string;
    required: boolean;
}[]): string;
export declare function generateEnumScript(items: {
    name: string;
}[]): string;
export declare function getJsTypeName(type: TypeData): string;
export declare function typeIsList(type: TypeData): boolean;
export declare function typeIsRequired(type: TypeData): boolean;
export declare function getTypeName(type: TypeData): string;
export declare function getTypeKind(type: TypeData): string;
export declare type GeneratedInfo = {
    name: string;
    data: string;
};
export declare type TypeData = {
    kind: string;
    name: string;
    fields?: TypeFieldData[];
    inputFields?: TypeFieldData[];
    enumValues?: TypeFieldData[];
    ofType?: TypeData;
};
export declare type TypeFieldData = {
    name: string;
    args: TypeArgData[];
    type: TypeData;
};
export declare type TypeArgData = {
    name: string;
    type: TypeData;
};
export declare type ActionType = "query" | "mutation";
