"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var path_1 = require("path");
var got = require("got");
var url_1 = require("url");
var SchemaData = (function () {
    function SchemaData(schema) {
        this.schema = schema;
    }
    SchemaData.prototype.getTypeByName = function (name) {
        return this.schema.data.__schema.types.find(function (type) { return type.name === name; });
    };
    SchemaData.prototype.typeIsObject = function (type) {
        return this.isOfType(type, ["OBJECT", "INPUT_OBJECT"]);
    };
    SchemaData.prototype.typeIsObjectOrEnum = function (type) {
        return this.isOfType(type, ["OBJECT", "INPUT_OBJECT", "ENUM"]);
    };
    SchemaData.prototype.typeIsEnum = function (type) {
        return this.isOfType(type, ["ENUM"]);
    };
    SchemaData.prototype.isOfType = function (type, types) {
        var schema = this.schema;
        var invalidNames = [schema.data.__schema["queryType"].name];
        if (schema.data.__schema["mutationType"]) {
            invalidNames.push(schema.data.__schema["mutationType"].name);
        }
        var name = getTypeName(type);
        var kind = getTypeKind(type);
        return (name.indexOf("__") !== 0 &&
            invalidNames.indexOf(name) < 0 &&
            types.indexOf(kind) > -1);
    };
    SchemaData.create = function (url, headers) {
        return __awaiter(this, void 0, void 0, function () {
            var parsedUrl, response, data, schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!url) {
                            throw new Error("url is required!");
                        }
                        headers = headers || {};
                        headers["content-type"] = headers["content-type"] || "application/json";
                        parsedUrl = url_1.parse(url);
                        headers["origin"] =
                            headers["origin"] || parsedUrl.protocol + "//" + parsedUrl.hostname;
                        return [4, got(url, {
                                headers: headers,
                                body: { query: schemaQuery, variables: null },
                                method: "POST",
                                json: true
                            })];
                    case 1:
                        response = _a.sent();
                        if (!(response.statusCode >= 400)) return [3, 3];
                        return [4, response.body];
                    case 2:
                        data = _a.sent();
                        throw new Error("Bad response(" + response.statusCode + ") from server: " + data);
                    case 3: return [4, response.body];
                    case 4:
                        schema = _a.sent();
                        return [2, new SchemaData(schema)];
                }
            });
        });
    };
    return SchemaData;
}());
exports.SchemaData = SchemaData;
var schemaQuery = "\n    query IntrospectionQuery {\n      __schema {\n        queryType { name }\n        mutationType { name }\n        subscriptionType { name }\n        types {\n          ...FullType\n        }\n        directives {\n          name\n          description\n          locations\n          args {\n            ...InputValue\n          }\n        }\n      }\n    }\n\n    fragment FullType on __Type {\n      kind\n      name\n      description\n      fields(includeDeprecated: true) {\n        name\n        description\n        args {\n          ...InputValue\n        }\n        type {\n          ...TypeRef\n        }\n        isDeprecated\n        deprecationReason\n      }\n      inputFields {\n        ...InputValue\n      }\n      interfaces {\n        ...TypeRef\n      }\n      enumValues(includeDeprecated: true) {\n        name\n        description\n        isDeprecated\n        deprecationReason\n      }\n      possibleTypes {\n        ...TypeRef\n      }\n    }\n\n    fragment InputValue on __InputValue {\n      name\n      description\n      type { ...TypeRef }\n      defaultValue\n    }\n\n    fragment TypeRef on __Type {\n      kind\n      name\n      ofType {\n        kind\n        name\n        ofType {\n          kind\n          name\n          ofType {\n            kind\n            name\n            ofType {\n              kind\n              name\n              ofType {\n                kind\n                name\n                ofType {\n                  kind\n                  name\n                  ofType {\n                    kind\n                    name\n                  }\n                }\n              }\n            }\n          }\n        }\n      }\n    }\n  ";
function saveCodeFile(data, fileName) {
    var content = data.map(function (item) { return item.data; }).join("\n\n");
    fs_1.writeFileSync(path_1.join(__dirname, "..", "..", "src", fileName + ".ts"), content, "utf8");
}
exports.saveCodeFile = saveCodeFile;
function generateTypeScriptType(items) {
    return "{ " + items
        .map(function (item) { return "" + item.name + (item.required ? "" : "?") + ": " + item.type; })
        .join(", ") + " } ";
}
exports.generateTypeScriptType = generateTypeScriptType;
function generateEnumScript(items) {
    return "{ " + items.map(function (item) { return item.name + " = \"" + item.name + "\""; }).join(", ") + " } ";
}
exports.generateEnumScript = generateEnumScript;
function getJsTypeName(type) {
    var name = getTypeName(type);
    var jsName = name;
    switch (name) {
        case "ID":
        case "String":
            jsName = "string";
            break;
        case "Int":
        case "Float":
            jsName = "number";
            break;
        case "JSON":
            jsName = "any";
            break;
        case "Boolean":
            jsName = "boolean";
            break;
    }
    if (typeIsList(type)) {
        jsName += "[]";
    }
    return jsName;
}
exports.getJsTypeName = getJsTypeName;
function typeIsList(type) {
    return ((type.kind === "NON_NULL" && type.ofType.kind === "LIST") ||
        type.kind === "LIST");
}
exports.typeIsList = typeIsList;
function typeIsRequired(type) {
    return type.kind === "NON_NULL";
}
exports.typeIsRequired = typeIsRequired;
function getTypeName(type) {
    if (~["NON_NULL", "LIST"].indexOf(type.kind)) {
        return getTypeName(type.ofType);
    }
    return type.name;
}
exports.getTypeName = getTypeName;
function getTypeKind(type) {
    if (~["NON_NULL", "LIST"].indexOf(type.kind)) {
        return getTypeKind(type.ofType);
    }
    return type.kind;
}
exports.getTypeKind = getTypeKind;
