"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var schema_1 = require("./schema");
var generator_1 = require("./generator");
var TypesGenerator = (function (_super) {
    __extends(TypesGenerator, _super);
    function TypesGenerator(schemaData, file) {
        var _this = _super.call(this, file) || this;
        _this.schemaData = schemaData;
        return _this;
    }
    TypesGenerator.prototype.getContent = function () {
        return __awaiter(this, void 0, void 0, function () {
            var schema, typeNames, types, data, enumNames, enumTypes, enums;
            var _this = this;
            return __generator(this, function (_a) {
                schema = this.schemaData.schema;
                typeNames = schema.data.__schema.types
                    .map(function (t) { return _this.schemaData.getTypeByName(t.name); })
                    .filter(function (type) { return _this.schemaData.typeIsObject(type); });
                types = typeNames.map(function (name) {
                    return _this.schemaData.getTypeByName(name.name);
                });
                data = types
                    .map(function (item) { return ({
                    name: item.name,
                    fields: (item.fields || item.inputFields).map(function (field) { return ({
                        name: field.name,
                        type: schema_1.getJsTypeName(field.type),
                        required: schema_1.typeIsRequired(field.type)
                    }); })
                }); })
                    .map(function (item) {
                    return "export type " + item.name + " = " + schema_1.generateTypeScriptType(item.fields);
                });
                data = data.concat(types.map(function (type) {
                    return "export const " + type.name + "StringFields = '" + _this.getTypeStringFields(type) + "';";
                }));
                enumNames = schema.data.__schema.types
                    .map(function (t) { return _this.schemaData.getTypeByName(t.name); })
                    .filter(function (type) { return _this.schemaData.typeIsEnum(type); });
                enumTypes = enumNames.map(function (name) {
                    return _this.schemaData.getTypeByName(name.name);
                });
                enums = enumTypes.map(function (item) { return "export enum " + item.name + " " + schema_1.generateEnumScript(item.enumValues); });
                data = data.concat(enums);
                return [2, data.join("\n\n")];
            });
        });
    };
    TypesGenerator.prototype.getTypeStringFields = function (type, parent) {
        var _this = this;
        if (parent === void 0) { parent = {}; }
        var fields = type.fields || type.inputFields;
        return fields
            .map(function (field) {
            var fieldsType = _this.schemaData.getTypeByName(schema_1.getTypeName(field.type));
            var fieldKey = field.name + "-" + fieldsType.name;
            var isObject = _this.schemaData.typeIsObject(fieldsType);
            if (isObject) {
                if (!parent[fieldKey] || parent[fieldKey] < 1) {
                    parent[fieldKey] = parent[fieldKey] || 0;
                    parent[fieldKey]++;
                    return field.name + " { " + _this.getTypeStringFields(fieldsType, parent) + " }";
                }
                else {
                    console.log("no object: " + field.name + " " + fieldsType.name + ", " + JSON.stringify(parent));
                }
            }
            else {
                return field.name;
            }
        })
            .filter(function (item) { return !!item; })
            .join(" ");
    };
    return TypesGenerator;
}(generator_1.FileGenerator));
exports.TypesGenerator = TypesGenerator;
