import { Index } from "./utils";
import { GraphQlRequestResult, GraphQlQueryType, GraphQlQueryItems, IGraphQlQueryExecutor } from "./graphql";
export declare type GraphQLQueryExecutorData = {
    query: string;
    variables: Index<any>;
};
export interface IGraphQlQueryExecutorRequest {
    (data: string): Promise<any>;
}
export declare class GraphQlQueryExecutor implements IGraphQlQueryExecutor {
    private request;
    constructor(request: IGraphQlQueryExecutorRequest);
    execute<T>(type: GraphQlQueryType, items: GraphQlQueryItems): Promise<GraphQlRequestResult<T>>;
    protected fetch(data: GraphQLQueryExecutorData): Promise<any>;
    protected formatQueryData(type: GraphQlQueryType, items: GraphQlQueryItems): GraphQLQueryExecutorData;
}
