export interface IDataMapper<R = any, V = any> {
    (value: V): R;
}
export declare type GraphQlQueryItem<TName extends string> = {
    name: TName;
    fields?: string;
    variables?: {
        type?: string;
        name: string;
        value: any;
        varName?: string;
    }[];
    mapper?: IDataMapper;
};
export declare type GraphQlQueryItemInput = {
    fields: string;
};
export declare type GraphQlRequestResult<T = {}> = {
    data: T;
    errors?: Error[];
};
export declare type GraphQlQueryType = "query" | "mutation";
export interface GraphQlQueryItems<TName extends string = string> {
    [index: string]: GraphQlQueryItem<TName>;
}
export interface IGraphQlQueryExecutor {
    execute<T>(type: GraphQlQueryType, items: GraphQlQueryItems): Promise<GraphQlRequestResult<T>>;
}
